#include <gtest/gtest.h>
#include "solution.hpp"

TEST(Lambda, accumulateIntegers) {
    std::array<int,10> numbers {0,1,2,3,4,5,6,7,8,9};
    ASSERT_EQ(sum1(numbers,5),10);
    ASSERT_EQ(sum1(numbers,4),6);
    ASSERT_EQ(sum1(numbers,3),3);
}

TEST(Lambda, accumulateStrings) {
    std::array<std::string,5> fruits {"apples","oranges","bananas","mangos","plantain"};
    ASSERT_TRUE(sum2(fruits,8) == std::string("applesorangesbananasmangos"));
    ASSERT_TRUE(sum2(fruits,7) == std::string("applesmangos"));
    ASSERT_TRUE(sum2(fruits,6) == std::string(""));
}

TEST(Lambda, sortStrings) {
    std::array<std::string,5> fruits {"apples","oranges","bananas","mangos","plantain"};
    sort1(fruits);
    ASSERT_TRUE(fruits[0] == std::string("apples"));
    ASSERT_TRUE(fruits[1] == std::string("bananas"));
    ASSERT_TRUE(fruits[2] == std::string("mangos"));
    ASSERT_TRUE(fruits[3] == std::string("oranges"));
    ASSERT_TRUE(fruits[4] == std::string("plantain"));
}

TEST(Lambda, sortStrings2) {
    std::array<std::string,5> fruits {"apples","oranges","bananas","mangos","plantain"};
    sort2(fruits);
    ASSERT_TRUE(fruits[0] == std::string("plantain"));
    ASSERT_TRUE(fruits[1] == std::string("oranges"));
    ASSERT_TRUE(fruits[2] == std::string("mangos"));
    ASSERT_TRUE(fruits[3] == std::string("bananas"));
    ASSERT_TRUE(fruits[4] == std::string("apples"));
}

TEST(Lambda, returnLambda) {
    auto lambda = getLambda();
    ASSERT_EQ(lambda(2,3),-1);
    ASSERT_EQ(lambda(3,2),1);
    ASSERT_EQ(lambda(5,6),lambda(13,14));
}
